<?php
class Group
{
	public $id;
	public $id_project;
	public $id_domain;
	public $rid;
	public $name;

	public function __construct($id = 0)
	{
		$id = intval($id);

		if ($id !== 0)
		{
			$this->id = $id;
			$this->load();
		}
		else return False;
	}

	public function listAll()
	{
		global $_db, $_project;

		return $_db->query('SELECT * FROM groups WHERE id_project='. $_project->id .' ORDER BY name');
	}

	function insert()
	{
		global $_db, $_project;

		$this->id_project = intval($this->id_project);
		$this->id_domain = intval($this->id_domain);
		$this->rid = intval($this->rid);
		$this->name = mysql_real_escape_string($this->name);

		$vars = array('id_project' => $this->id_project,
			'id_domain' => $this->id_domain,
			'rid' => $this->rid,
			'name' => $this->name
			);
		
		$this->id = $_db->insert_unique('groups', $vars);

		return $this->id;
	}

	function update()
	{
		global $_db, $_project;

		$this->id_project = intval($this->id_project);
		$this->id_domain = intval($this->id_domain);
		$this->rid = intval($this->rid);
		$this->name = mysql_real_escape_string($this->name);

		$res = $_db->query("UPDATE groups SET id_project=$this->id_project, id_domain=$this->id_domain, rid=$this->rid,
			name='$this->name' WHERE id=$this->id AND id_project=$this->id_project");

		return $res;
	}

	function load()
	{
		global $_db, $_project;

		$res = $_db->query('SELECT * FROM groups WHERE id='. $this->id .' AND id_project='. $_project->id);
		if ($res)
		{
			$this->id_project = $res[$this->id]['id_project'];
			$this->id_domain = $res[$this->id]['id_domain'];
			$this->rid = $res[$this->id]['rid'];
			$this->name = $res[$this->id]['name'];
		}
	}

	function addUserByUid($uid)
	{
		global $_db, $_project;

		$uid = intval($uid);

		$vars = array('id_project' => $this->id_project,
			'id_domain' => $this->id_domain,
			'id_user' => $uid,
			'id_group' => $this->id);
		
		$this->id = $_db->insert_unique('usergroups', $vars);

		return $this->id;
	}

	function listUsers()
	{
		global $_db, $_project;

		$res = $_db->query("SELECT u.* FROM users u LEFT JOIN usergroups ug ON (ug.id_group = $this->id) WHERE u.id_project=$_project->id AND u.rid=ug.id_user ORDER BY u.name");

		return $res;
	}
}
?>
