<?php
class Hostconf
{
	public $id_project;
	public $resolv;
	public $routes;
	public $ifconfig;

	public $ip;
	public $network;
	public $netmask;
	public $gateway;
	public $dns = array();
	public $domain;

	public $loaded = False;

	public function __construct($id_project = 0)
	{
		global $_db;
		$this->id_project = intval($id_project);

		$res = $_db->query('SELECT * FROM hostconf WHERE id_project='. $this->id_project);

		if (count($res))
		{
			//$this->id_project = $res[0]['id_project'];
			$this->resolv = $res[0]['resolv'];
			$this->routes = $res[0]['routes'];
			$this->ifconfig = $res[0]['ifconfig'];
			$this->loadvars();
			$this->loaded = True;
		}

		else $this->load();
	}

	private function loadvars()
	{
		$tab = explode("\n", $this->ifconfig);
		foreach ($tab as $line)
		{
			if (substr(trim($line), 0, 10) == 'inet addr:')
			{
				$this->ip = trim(substrft($line, 'inet addr:', ' '));
				$this->netmask = trim(substrf($line, 'Mask:'));
				$this->network = long2ip((ip2long($this->ip)) & (ip2long($this->netmask))) .'/'. cidr($this->netmask);
			}
		}

		$tab = explode("\n", $this->routes);
		foreach ($tab as $line)
		{
			if (strpos($line, 'UG'))
				$this->gateway = get_elem($line, 1);
		}

		$tab = explode("\n", $this->resolv);
		foreach ($tab as $line)
		{
			if (substr($line, 0, 6) == 'domain' or substr($line, 0, 6) == 'search')
				$this->domain = get_elem($line, 1);
			if (substr($line, 0, 10) == 'nameserver')
				$this->dns[] = get_elem($line, 1);
		}
	}

	private static function countSetbits($int)
	{
		$int = $int - (($int >> 1) & 0x55555555);
		$int = ($int & 0x33333333) + (($int >> 2) & 0x33333333);
		return (($int + ($int >> 4) & 0xF0F0F0F) * 0x1010101) >> 24;
	}

	public function load()
	{
		global $_db;

		$if = shell_exec("route -n | grep ^0.0.0.0 | awk '{print $8}'");
		$this->resolv = file_get_contents('/etc/resolv.conf');
		$this->routes = shell_exec('/sbin/route -n');
		$this->ifconfig = shell_exec('/sbin/ifconfig '. trim($if));
		$this->loadvars();
		$this->loaded = True;

		return $_db->query("INSERT INTO hostconf VALUES($this->id_project, '$this->resolv', '$this->routes', '$this->ifconfig')");
	}
}
?>
