<?php
class Port
{
	public $id;
	public $id_project;
	public $id_host;
	public $proto;
	public $number;
	
	public function __construct($id = 0)
	{
		$id = intval($id);
		
		if ($id !== 0)
		{
			$this->id = $id;
			$this->load();
		}
		else return False;
	}
	
	public function listAll()
	{
		global $_db, $_project;
		
		return $_db->query('SELECT * FROM ports WHERE id_project='. $_project->id .' ORDER BY proto, number');
	}
	
	public function listByHost($id_host)
	{
		global $_db, $_project;
		
		$ports = $_db->query('SELECT p.id, h.name AS hostname, h.ipaddr, p.proto, p.number
			FROM ports p LEFT JOIN hosts h ON (p.id_host = h.id) WHERE p.id_host='. intval($id_host) .' AND p.id_project='. $_project->id); 
		
		$ret = array();
		foreach ($ports as $p)
			$ret[$p['id']][] = array('id' => $p['id'], 'ip' => $p['ipaddr'], 'hostname' => $p['hostname'], 'proto' => $p['proto'], 'number' => $p['number']);

		return $ret;
	}
	
	function listHosts($proto, $number)
	{
		global $_db, $_project;

		$proto = mysql_real_escape_string($proto);
		$number = mysql_real_escape_string($number);

		$res = $_db->query("SELECT h.id, h.name, h.ipaddr FROM hosts h, ports p WHERE p.id_project=$_project->id AND p.id_host=h.id AND p.proto='$proto' AND p.number=$number ORDER BY h.ipaddr");

		return $res;
	}

	function insert()
	{
		global $_db, $_project;
		
		$this->id_project = intval($this->id_project);
		$this->id_host = intval($this->id_host);
		$this->proto = mysql_real_escape_string($this->proto);
		$this->number = intval($this->number);

		$vars = array('id_project' => $this->id_project,
			'id_host' => $this->id_host,
			'proto' => $this->proto,
			'number' => $this->number,
			);
		
		$this->id = $_db->insert_unique('ports', $vars);

		return $this->id;
	}
	
	function load()
	{
		global $_db, $_project;
		
		$res = $_db->query('SELECT * FROM ports WHERE id='. $this->id .' AND id_project='. $_project->id);
		if ($res)
		{
			$this->id_project = $res[$this->id]['id_project'];
			$this->id_host = $res[$this->id]['id_host'];
			$this->proto = $res[$this->id]['proto'];
			$this->number = $res[$this->id]['number'];
		}
	}
}
?>
