<?php
class User
{
	public $id;
	public $id_project;
	public $id_domain;
	public $rid;
	public $name;
	public $fullname;
	public $descr;
	public $nt;
	public $lm;
	public $pwd;
	
	public function __construct($id = 0)
	{
		$id = intval($id);
		
		if ($id !== 0)
		{
			$this->id = $id;
			$this->load();
		}
		else return False;
	}
	
	public function listAll()
	{
		global $_db, $_project;
		
		return $_db->query('SELECT * FROM users WHERE id_project='. $_project->id .' ORDER BY name');
	}

	function insert()
	{
		global $_db, $_project;
		
		$this->id_project = intval($this->id_project);
		$this->id_domain = intval($this->id_domain);
		$this->rid = intval($this->rid);
		$this->name = mysql_real_escape_string($this->name);
		$this->fullname = mysql_real_escape_string($this->fullname);
		$this->descr = mysql_real_escape_string($this->descr);
		$this->lm = mysql_real_escape_string($this->lm);
		$this->nt = mysql_real_escape_string($this->nt);
		$this->pwd = mysql_real_escape_string($this->pwd);

		$vars = array('id_project' => $this->id_project,
			'id_domain' => $this->id_domain,
			'rid' => $this->rid,
			'name' => $this->name,
			'fullname' => $this->fullname,
			'descr' => $this->descr,
			'lm' => $this->lm,
			'nt' => $this->nt,
			'pwd' => $this->pwd
			);
		
		$this->id = $_db->insert_unique('users', $vars);

		return $this->id;
	}
	
	function update()
	{
		global $_db, $_project;
		
		$this->id_project = intval($this->id_project);
		$this->id_domain = intval($this->id_domain);
		$this->rid = intval($this->rid);
		$this->name = mysql_real_escape_string($this->name);
		$this->fullname = mysql_real_escape_string($this->fullname);
		$this->descr = mysql_real_escape_string($this->descr);
		$this->lm = mysql_real_escape_string($this->lm);
		$this->nt = mysql_real_escape_string($this->nt);
		$this->pwd = mysql_real_escape_string($this->pwd);
		
		$res = $_db->query("UPDATE users SET id_project=$this->id_project, id_domain=$this->id_domain, rid=$this->rid,
			name='$this->name', fullname='$this->fullname', descr='$this->descr', lm='$this->lm', nt='$this->nt', pwd='$this->pwd'
			WHERE id=$this->id AND id_project=$this->id_project");
		
		return $res;
	}
	
	function load()
	{
		global $_db, $_project;
		
		$res = $_db->query('SELECT * FROM users WHERE id='. $this->id .' AND id_project='. $_project->id);
		if ($res)
		{
			$this->id_project = $res[$this->id]['id_project'];
			$this->id_domain = $res[$this->id]['id_domain'];
			$this->rid = $res[$this->id]['rid'];
			$this->name = $res[$this->id]['name'];
			$this->fullname = $res[$this->id]['fullname'];
			$this->descr = $res[$this->id]['descr'];
			$this->lm = $res[$this->id]['lm'];
			$this->nt = $res[$this->id]['nt'];
			$this->pwd = $res[$this->id]['pwd'];
		}
	}
	
	function listGroups()
	{
		global $_db, $_project;

		$res = $_db->query("SELECT g.id, g.name, g.rid FROM groups g, usergroups ug WHERE ug.id_user=$this->rid AND g.id=ug.id_group AND g.id_project=$_project->id AND g.id_domain=$this->id_domain ORDER BY g.rid");

		return $res;
	}
}
?>
