<?php
if (isset($_GET['disconnect']))
{
	setcookie('pid', NULL, -1);
	unset($_COOKIE['pid']);
}
if (!isset($_COOKIE['pid']) OR !is_numeric($_COOKIE['pid']))
{
	include_once 'conf/global.php';
	include_once 'class/Database.php';
	include_once 'class/Project.php';

	$_db = new Database();

	if (isset($_POST['submit']))
	{
		if ($_POST['submit'] == 'Create')
		{
			$_project = new Project();
			$_project->name = strip_tags($_POST['project_name']);
			if ($_project->name == $_POST['project_name'])
				$_project->insert();
			else die('Invalid project name');
		}
		elseif ($_POST['submit'] == 'Load')
		{
			$id = intval($_POST['project_id']);
			$_project = new Project($id);
		}

		setcookie('pid', $_project->id);
	}
	else
	{
		$projects = Project::listAll();
		echo '<!DOCTYPE html><html><head><title>NSAP - Network security assessment platform</title>
		<link rel="stylesheet" href="/css/main.css" type="text/css"></link>
		</head><body>
		<div class="loginbox">';
		echo '<h3>Network Security Assessment Platform</h3>';
		if (isset($_GET['disconnect']))
			echo '<p><span class="err">Session disconnected</span></p>';
		echo '<p>Please select a project:</p>';
		echo '<p><form action="/" method="post">
		<select class="inputselect" name="project_id">';
		foreach ($projects as $id => $array)
			echo '<option value="'. $array['id'] .'">'. $array['name'] .'</option>';
		echo '</select>&nbsp;<input class="inputbutton" type="submit" name="submit" value="Load"></form></p>';

		echo '<p>Or create a new project:</p>';
		echo '<p><form action="/" method="post">
		<input class="inputtext" type="text" name="project_name" value="">&nbsp;<input class="inputbutton" type="submit" name="submit" value="Create"></form></p>
		</div></body></html>';
		die();
	}
}
$view = (isset($_GET['view']) ? '/'. $_GET['view'] : '/project');
$id = (isset($_GET['id']) ? '/'. $_GET['id'] : '');

echo '<HTML>
<HEAD>
<TITLE>NSAP - Network security assessment platform</TITLE>
</HEAD>
<frameset border="0" rows="20,*">
<frame name="nav" src="nav.php" frameborder="0" scrolling="no">
	<frameset border="0" cols="230,*">
	   <frame name="tree" src="tree.php" frameborder="0">
	   <frame name="main" src="/view'. $view . $id .'" frameborder="0">
	   <noframes><H1>Frames required</H1></noframes>
	</frameset>
</frameset>
</HTML>';
?>
