<?php
function link_routesinfo()
{
	return "<script>MakeCmdRequest('cmd_routesinfo', 'routesinfo', '', false);</script>".
	'<div class="cmd_line" id="cmd_routesinfo"><span class="wait">Retreiving routing table information ...</span></div>';
}
function run_routesinfo()
{
	global $_project;

	$local_subnets = array();
	$_hostconf = new Hostconf($_project->id);

	if ($_hostconf->loaded === False)
		$_hostconf->load();

	$cpt = array(0, 0);
	foreach (explode("\n", $_hostconf->routes) AS $r)
	{
		$tab = explode(' ', strip_sp($r));

		if (isset($tab[1]) and is_ip($tab[1]) and $tab[1] != '0.0.0.0')
		{
			$resolv = gethostbyaddr($tab[1]);

			$gw = new Host();
			$gw->id_project = $_project->id;
			$gw->name = ($resolv ? $resolv : '?');
			$gw->ipaddr = $tab[1];
			if ($gw->insert())
			{
				$cpt[0]++;

				$role = new Role();
				$role->id_project = $_project->id;
				$role->id_host = $gw->id;
				$role->id_role = Role::getByName('Gateway');
				if ($role->insert()) $cpt[1]++;
			}

			if (!in_array($tab[0], array('0.0.0.0', '169.254.0.0')))
				$local_subnets[slash24($tab[0])] = 1;
		}
	}
	echo '<span class="confirm">Analysis of routing table returned '. $cpt[0] .' host'. ($cpt[0] > 1 ? 's' : '') .', '. 
		$cpt[1] .' role'. ($cpt[1] > 1 ? 's' : '') .' and '. 
		count($local_subnets) .' subnet'. (count($local_subnets) > 1 ? 's' : '') .'</span>';
}
?>
