<?php
function display_host($h, $class)
{
	return '<tr class="'. $class .'">
	<td><span class="host"><a href="/view/host/'. $h['id'] .'">'. (!empty($h['name']) ? $h['name'] : $h['ipaddr']) .'</a></span></td>
	<td align="center">'. $h['ipaddr'] .'</td>'."</tr>\n";
}
function display_role($r, $class)
{
	return '<tr class="'. $class .'">
	<td><span class="role"><a href="/view/role/'. $r['id'] .'">'. $r['name'] .'</a></span></td>
	<td align="center">'. $r['nb'] .'</td>'."</tr>\n";
}
if (isset($view) and $view == 'role')
{
	if (!empty($id)) // Show 1 role
	{
		$cpt = 0;
		$list = $_project->getHostsByRoleId($id);
		$role = Role::getNameById($id);

		echo '<fieldset><legend>Hosts with role: '. $role .' ('. count($list) .')</legend>';

		$modules = array();
		foreach (modules_by_role($role) AS $mod_name)
			$modules[$mod_name] = array('target' => 'all', 'role' => $id);

		echo modules($modules);

		if (!count($list))
			echo '<span class="err">No hosts with this role in database</span>';
		else
		{
			echo '<table cellspacing="0">
			<tr class="trhdr">
			  <td class="tdhdr" width="150">Hostname</td>
			  <td class="tdhdr" width="150" align="center">IP Address</td>
			</tr>'."\n";

			foreach ($list AS $id_host => $h)
				echo display_host($h, (($cpt++ % 2) ? 'tdrow2' : 'tdrow1'));

			echo '</table>';
		}
		echo '</fieldset>';

	}
	else // Show all roles
	{
		$cpt = 0;
		$list = $_project->getAllRoles();
		
		echo '<fieldset><legend>All roles ('. count($list) .')</legend>';

		if (!count($list))
			echo '<span class="err">No roles for this project yet</span>';
		else
		{
			echo '<table cellspacing="0">
			<tr class="trhdr">
			  <td class="tdhdr" width="150">Role</td>
			  <td class="tdhdr" align="center">Nb of hosts</td>
			</tr>'."\n";

			foreach ($list AS $r)
				echo display_role($r, (($cpt++ % 2) ? 'tdrow2' : 'tdrow1'));

			echo '</table>';
		}
		echo '</fieldset>';
	}
}
?>
