<?php
class Project
{
	public $id;
	public $name;
	public $create_date;
	
	public function __construct($id = 0)
	{
		$id = intval($id);
		
		if ($id !== 0)
		{
			$this->id = $id;
			$this->load();
		}
		else return false;
	}
	
	public function listAll()
	{
		global $_db;
		
		return $_db->query('SELECT id, name FROM projects ORDER BY name');
	}
	
	public function getHostsByRole($role)
	{
		global $_db;
		
		$role = mysql_real_escape_string($role);

		return $_db->query("SELECT h.ipaddr, hr.id_host AS id FROM hosts h, roles r, hostroles hr WHERE r.name='$role' AND hr.id_role=r.id AND h.id_project=$this->id AND hr.id_host=h.id;");
	}

	public function getHostsByRoleId($id_role)
	{
		global $_db;
		
		$id_role = intval($id_role);

		return $_db->query("SELECT h.ipaddr, hr.id_host AS id FROM hosts h, roles r, hostroles hr WHERE r.id='$id_role' AND hr.id_role=r.id AND h.id_project=$this->id AND hr.id_host=h.id;");
	}
	
	public function getAllRoles()
	{
		global $_db;

		return $_db->query("SELECT r.id, r.name, COUNT(hr.id_host) AS nb FROM roles r, hostroles hr WHERE hr.id_role=r.id AND hr.id_project=$this->id GROUP BY r.name ORDER BY r.name");
	}

	function insert()
	{
		global $_db;
		
		$this->name = mysql_real_escape_string($this->name);

		$vars = array('name' => $this->name);
		
		$this->id = $_db->insert_unique('projects', $vars);

		return $this->id;
	}
	
	function load()
	{
		global $_db;
		
		$res = $_db->query('SELECT * FROM projects WHERE id='. $this->id);
		if ($res)
		{
			$this->name = $res[$this->id]['name'];
			$this->create_date = $res[$this->id]['create_date'];
		}
	}
}
?>
