<?php
function display_user($u, $class)
{
	return '<tr align="center" class="'. $class .'">
	  <td align="left"><span class="user"><a href="/view/user/'. $u['id'] .'">'. $u['name'] .'</a></span></td>
	  <td>'. $u['fullname'] .'</td>
	  <td>'. $u['rid'] .'</td>
	  <td>'. $u['descr'] .'</td>
	  <td>'. $u['pwd'] .'</td>
	</tr>'."\n";
}
if (isset($view) and $view == 'group')
{
	if (!empty($id))
	{
		$cpt = 0;
		$id = intval($id);
		$g = new Group($id);

		$list = $g->listUsers();

		echo '<fieldset><legend>Users in group: '. $g->name .' ('. count($list) .')</legend>';

		if (!count($list))
			echo '<span class="err">No users in database</span>';
		else
		{
			echo '<table cellspacing="0">
			<tr class="trhdr">
			  <td class="tdhdr" width="150" align="center">Username</td>
			  <td class="tdhdr" width="150" align="center">Full Name</td>
			  <td class="tdhdr" width="150" align="center">UID</td>
			  <td class="tdhdr" width="200" align="center">Description</td>
			  <td class="tdhdr" width="200" align="center">Password</td>
			</tr>'."\n";

			foreach ($list AS $id_user => $u)
				echo display_user($u, (($cpt++ % 2) ? 'tdrow2' : 'tdrow1'));

			echo '</table>';
		}
		echo '</fieldset>';

	}
	else echo '<span class="err">No group found.</span>';
}
?>
