<?php
function p(&$data) { echo '<pre>'. strip_tags(print_r($data, true)) .'</pre>'; }
function strpop($str, $n = 1) { return substr($str, 0, 0 - $n); }
function strshift($str, $n = 1) { return substr($str, $n); }
function ifset(&$var) { return isset($var) ? $var : false; }
function ifnempty(&$var) { return (isset($var) && !empty($var)) ? $var : ''; }
function ifnset(&$var, $what = false) { return isset($var) ? $var : $what; }
function dedup($str, $sep = ' ') { return preg_replace('/('. (strpos('..\\ [](){}', $sep) ? '\\' : '') . $sep .'+)/', $sep, $str); }
function get_elem($str, $n = 0, $sep = ' ') {
	$ret = dedup($str, $sep);
	$tab = explode($sep, trim($ret));
	return isset($tab[$n]) ? trim($tab[$n]) : false; }
function substrf($str, $sep) { return strpos($str, $sep) !== false ? substr($str, strpos($str, $sep) + strlen($sep)) : $sep; }
function substrt($str, $sep) { return strpos($str, $sep) !== false ? substr($str, 0, strpos($str, $sep)) : $str; }
function substrft($str, $sep1, $sep2) {
	$ret = substrf($str, $sep1);
	return substrt($ret, $sep2); }
function if_equals($a, $b, $ret, $else = '') { return ($a == $b ? $ret : $else); }
function startswith($str, $chars) { return (substr($str, 0, strlen($chars)) == $chars) ? True : False; }
function cidr($netmask)
{
	$tab = array(8 => '255.0.0.0', 9 => '255.128.0.0', 10 => '255.192.0.0', 11 => '255.224.0.0', 12 => '255.240.0.0',
	13 => '255.248.0.0', 14 => '255.252.0.0', 15 => '255.254.0.0', 16 => '255.255.0.0', 17 => '255.255.128.0',
	18 => '255.255.192.0', 19 => '255.255.224.0', 20 => '255.255.240.0', 21 => '255.255.248.0', 22 => '255.255.252.0',
	23 => '255.255.254.0', 24 => '255.255.255.0', 25 => '255.255.255.128', 26 => '255.255.255.192', 27 => '255.255.255.224',
	28 => '255.255.255.240', 29 => '255.255.255.248', 30 => '255.255.255.252');
	
	return array_search($netmask, $tab);
}
function slash24($ip_addr)
{
	$bytes = explode('.', $ip_addr);
	array_pop($bytes);
	
	return join('.', $bytes) .'.0/24';
}
function refreshtree(){echo '<script>parent.frames[\'tree\'].location.reload();</script>';}
function strip_sp($str)
{
	$str = str_replace("\t", ' ', $str);
	$str = preg_replace('/\s+/', ' ', $str);
	
	return $str;
}
function set_and_not_empty($array, $indexes) {
	if (is_array($indexes))
	{
		foreach ($indexes AS $i)
			if (!isset($array[$i]) or empty($array[$i]))
				return False;
	}
	else if (!isset($array[$indexes]) or empty($array[$indexes]))
		return False;
	
	return True;
}
function is_ip($str){return preg_match("/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\$/", $str);}
function filter_cmd($cmd)
{
	$cmd = substrt($cmd, ';');
	$cmd = substrt($cmd, '|');
	$cmd = substrt($cmd, '&');
	$cmd = substrt($cmd, '>');
	$cmd = substrt($cmd, '<');
	return $cmd;
}
function hdr()
{
	return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html><head><title>NSAP - Network security assessment platform</title>
<link rel="stylesheet" href="/css/main.css" type="text/css"></link>
<script type="text/javascript" src="/js/ajax.js"></script>
</head><body id="main">';
}
function ftr()
{
	return '</body></html>';
}
?>
