<?php
function modules($modules = array())
{
	$ret = '';

	foreach ($modules AS $m => $obj)
	{
		include_once 'modules/'. $m .'.php';
		
		$fct = "link_$m";
		if (function_exists($fct))
			$ret .= $fct($obj);
	}
	
	return $ret;
}
function modules_by_role($role)
{
	$arr = array(
		'MSSQL Database' => array('mssqlsa'),
		'Web Server' => array('httpenum'),
		'Web Server (SSL)' => array('httpenum'),
		'Web or Proxy Server' => array('httpenum'),
	);
	
	return isset($arr[$role]) ? $arr[$role] : array();
}
function modules_by_app($app_name)
{
	$arr = array(
		'mssql' => array('mssqlsaexec'),
	);

	return isset($arr[$app_name]) ? $arr[$app_name] : array();
}
?>
