<?php
function link_msdcs()
{
	return "<script>MakeCmdRequest('cmd_msdcs', 'msdcs', '', false);</script>".
	'<div class="cmd_line" id="cmd_msdcs"><span class="wait">Retreiving Domain controllers ...</span></div>';
}
function run_msdcs()
{
	global $_project;
	
	$cpt = array(0, 0);
	foreach (Domain::getFqdns() AS $d)
	{
		$cmd = new Cmd("host gc._msdcs.". $d['fqdn']);
		$output = $cmd->exec();

		foreach ($output AS $line)
		{
			$line = strip_sp($line);
			if (strpos($line, 'has address'))
			{
				$tab = explode(' ', $line);
				$ip = trim($tab[3]);
				if (is_ip($ip))
				{
					$h = new Host();
					$h->id_project = $_project->id;
					$h->id_domain = intval($d['id']);
					$h->name = '';
					$h->ipaddr = $ip;
					if ($h->insert())
					{
						$cpt[0]++;

						$role = new Role();
						$role->id_project = $_project->id;
						$role->id_host = $h->id;
						$role->role = 'Domain Controller';
						if ($role->insert()) $cpt[1]++;
					}
				}
			}
		}
	}
	echo '<span class="confirm">Queries for MS domain controllers returned '. $cpt[0] .' host'. ($cpt[0] > 1 ? 's' : '') .' and '. 
		$cpt[1] .' role'. ($cpt[1] > 1 ? 's' : '') .'</span>';
}
?>
