<?php
if (isset($view) and isset($id) and $view != 'cmd')
{
	echo '<fieldset>';
	if (isset($_POST['submit']))
	{
		echo '<legend>Running command</legend>';
		echo "<script>MakeCmdRequest('cmd_run', '". $view ."', '". http_build_query($_POST) ."', true);</script>";
		echo '<div class="cmd_line" id="cmd_run"><span class="wait">Executing command on target(s)...</span></div>';
	}
	else echo form_mssqlsaexec(filter_cmd($id));
	echo '</fieldset>';
}

function link_mssqlsaexec($target)
{
	if (is_array($target) AND isset($target['target']))
		$target = $target['target'];
	
	return "<p id=\"cmd_mssqlsaexec_$target\"><a href=\"/view/mssqlsaexec/$target\">Execute command on ". (is_ip($target) ? $target : 'these servers') ."</a></p>";
}

function run_mssqlsaexec()
{
	global $_project;
	
	if (!set_and_not_empty($_POST, array('target', 'cmd')))
		return;

	$cpt = 0;
	$target = filter_cmd($_POST['target']);
	$cmd = strip_tags($_POST['cmd']);
	
	echo form_mssqlsaexec($target, False, $cmd) ."<br>";

	if ($target == 'all')
	{
		$hosts = $_project->getHostsByRole('MSSQL Database');
		foreach ($hosts AS $id_host => $h)
		{
			$app = Appuser::getByHostApp($id_host, 'mssql');

			if (do_mssqlsaexec($h['ipaddr'], $id_host, $cmd, $app['username'], $app['password']))
				$cpt++;
		}
		
		if ($cpt)
			echo '<span class="confirm">Command execution successful on '. $cpt .' server(s)</span>';
		else
			echo '<span class="err">Command execution failed</span>';		
	}
	
	elseif (is_ip($target))
	{
		$host = Host::getByIp($target);
		if (isset($host->id) AND $host->id > 0)
		{
			$app = Appuser::getByHostApp($host->id, 'mssql');

			$output = do_mssqlsaexec($target, $host->id, $cmd, $app['username'], $app['password']);

			if ($output != False)
			{
				$output = htmlentities($output);
				$output = str_replace(' ', '&nbsp;', $output);
				$output = '<span style="font-family: Lucida Console, monospace;">'. nl2br($output) .'</span>';

				echo '<span class="confirm">'. $target .': "'. $cmd .'" :</span><br><br>'. $output .'<br>';
			}
			else
				echo '<span class="err">Command execution on '. $target .' failed</span>';	
		}
		else echo '<span class="err">Specified host does not exist in database</span>';
	}
}

function do_mssqlsaexec($target, $id_host, $cmd, $usr, $pwd)
{
	global $_project;
	
	if (!is_ip($target))
		return False;

	$cmd = new Cmd("/usr/local/bin/mssql_exec_cmd '$target' '$usr' '$pwd' \"$cmd\"");
	$output = $cmd->exec();

	return count($output) > 1 ? join("\n", $output) : False;
}

function form_mssqlsaexec($target, $hdr = true, $cmd = 'dir C:\\')
{
	$ret = ($hdr ? (hdr() .'<legend>Execute command via xp_cmdshell</legend>') : '') .
	'<form action="" method="POST">
	<table cellspacing="0">'.
	($hdr ? '<tr class="trhdr"><td colspan="2">Attack configuration: '. $target .'</td></tr>' : '') .
	'<tr class="tdrow2"><td>Command</td><td><input type="text" size="60" value="'. $cmd .'" name="cmd" /></td></tr>
	<tr class="tdrow1"><td colspan="2" align="right">
		<input type="submit" name="submit" value="Run command ..." />
		<input type="hidden" name="target" value="'. $target .'" /></td></tr></table></form>';
	
	return $ret;
}
?>
