<?php
function link_policy($arr)
{
	if (isset($arr['target']))
	{
		if (isset($arr['run']) and $arr['run'] == 'auto')
		{
			return "<script>MakeCmdRequest('cmd_policy". $arr['target'] ."', 'policy', '". http_build_query($arr) ."', false);</script>".
			'<div class="cmd_line" id="cmd_policy'. $arr['target'] .'"><span class="wait">Retrieve domain policy from '. 
			($arr['target'] == 'all' ? 'all Domain Controllers' : 'this Domain Controller') .' ...</span></div>';
		}
		else
		{
			return '<p id="cmd_policy_'. $arr['target'] .'">'.
			"<a href=\"#\" onclick=\"this.className='wait';
			MakeCmdRequest('cmd_policy_". $arr['target'] ."', 'policy', '". http_build_query($arr) ."', false);
			return false;\">Retrieve domain policy from ". ($arr['target'] == 'all' ? 'all Domain Controllers' : 'this Domain Controller') ." ...</a></p>";
		}
	}
}
function run_policy()
{
	global $_project;

	if (!set_and_not_empty($_POST, 'target')) return;
	$target = filter_cmd($_POST['target']);
	$success = False;

	if ($target == 'all') // run polenum against all DCs
	{
		foreach (Domain::getFqdns() AS $d)
		{
			$domain = new Domain($d['id']);
			$dns_srvs = $_project->getHostsByRole('Domain Controller');

			foreach ($dns_srvs AS $id_host => $s)
			{
				$success = do_policy($domain, $s['ipaddr']);

				if (!empty($domain->policy))
					break ;
			}
		}

		if ($success)
		{
			if (isset($_POST['aff']) AND $_POST['aff'] == 'res')
				echo str_replace('\n', '', $domain->policy);
			else
				echo '<span class="confirm">Domain policy retrieved from '. $s['ipaddr'] .'</span>';
		}
	}

	elseif (is_ip($target)) // run polenum against one target
	{
		$domain = Domain::getByDnsIp($target);
		if ($domain)
			$success = do_policy($domain, $target);

		if ($success)
		{
			if (isset($_POST['aff']) AND $_POST['aff'] == 'res')
				echo $domain->policy;
			else
				echo '<span class="confirm">Domain policy retrieved from '. $target .'</span>';
		}
	}

	if (!$success)
		echo '<span class="err">Unable to retrieve domain policy</span>';
}

function do_policy($domain, $dns)
{
	global $_project;

	$cmd = new Cmd("python /opt/py/polenum.py ". $dns);
	$output = join("\n", $cmd->exec());

	if (!strpos($output, 'failed:'))
	{
		$output = substr($output, strpos($output, '[+] Minimum password length'));
		$domain->policy = stripslashes($output);
		$domain->policy = nl2br($domain->policy);
		$domain->update();

		return True;
	}

	return False;
}
?>
